package com.uas.service.Impl;

import com.uas.service.DownloadFilePathService;
import com.uas.util.*;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.http.entity.ContentType;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;
import java.util.Map;

/**
 * @author koul
 */
@Service
public class DownloadFilePathServiceImpl implements DownloadFilePathService {

	@Override
    public void runDownloadFilePath(){

        //博思达香港-准时达
		downloadFilePath("BSD_HK-ZSD","BSD_HK");
	}
	
	@SuppressWarnings("unchecked")
	@Async("taskExecutor")
	@Override
	public void downloadFilePath(String depot,String sob){
		BaseUtil.getLogger().info("download file" + " from "+depot);
		FTPClient client = null;
		SFTPUtil sftp = null;
		Connection connect = null;
    	try {
    		Map<String,Object> servMap = JdbcUtil.getFtpConfigs();
			Map<String,Object> ftpMap = (Map<String,Object>)servMap.get(depot);
			String fileName = "";
			if ("BSD_HK-ZSD".equals(depot)){
				sftp = new SFTPUtil(ftpMap.get("user").toString(),ftpMap.get("password").toString(),
						ftpMap.get("ip").toString(),
						Integer.parseInt(ftpMap.get("port").toString()));
				if(sftp!=null){
					sftp.login();
					List<MultipartFile> files = sftp.downloadMultipartFile(ftpMap.get("file").toString());
					if(files!=null&&files.size()>0){
						connect = JdbcUtil.getConnectBySob(sob);
						if(connect!=null){
							for (MultipartFile file:files) {
								try {
									Statement statement = connect.createStatement();
									fileName += "," + file.getOriginalFilename().replaceAll(",", "，");
									boolean bol = FileUtil.fileUp(statement, file, sob);
									if (bol) {
                                        if ("BSD_HK-ZSD".equals(depot)) {
                                            Boolean rename =
                                                    sftp.rename("/" + ftpMap.get("file").toString() + "/" + file.getName(),
                                                            "/bosidahkhub/signback_bak/" + file.getName());
                                        }
										if ("BSD_HK-ZSD".equals(depot)) {
											Boolean rename =
													sftp.rename("/" + ftpMap.get("file").toString() + "/" + file.getName(), "/bosidahkhub/error_signback/" + file.getName());
										}
									}
								} catch (Exception e) {
									e.printStackTrace();
									BaseUtil.getLogger().error(e.toString());
									continue;
								}
							}
						}
					}
				}
			}else {
				client = FtpUtil.connect(ftpMap);
				if(client!=null){
					List<File> files = FtpUtil.downloadAllFileByDir(client,ftpMap.get("file").toString());
					if(files!=null&&files.size()>0){
						connect = JdbcUtil.getConnectBySob(sob);
						if(connect!=null){

							for (File file:files) {
								try {
									Statement statement = connect.createStatement();
									fileName += "," + file.getName();
									FileInputStream fileInputStream = new FileInputStream(file);
									MultipartFile file1 = new MockMultipartFile(file.getName(), file.getName(),
											ContentType.APPLICATION_OCTET_STREAM.toString(), fileInputStream);
									boolean bol = FileUtil.fileUp(statement, file1, sob);
									if (bol) {
										//移动处理完的文件到bak文件夹下
										client.rename(file.getName(), "/HKHub/UPSTAR/signback_bak/" + file.getName());
									}else {
										//移动处理完的文件到failed文件夹下
										client.rename(file.getName(), "/HKHub/UPSTAR/error_signback/" + file.getName());
									}
								} catch (Exception e) {
									e.printStackTrace();
									BaseUtil.getLogger().error(e.toString());
									continue;
								}
							}
						}
					}
				}
			}
			if(!"".equals(fileName)){
				BaseUtil.logDownload(fileName.substring(1),ftpMap.get("ip").toString(),ftpMap.get("file").toString());
			}
    	} catch (Exception e) {
    		BaseUtil.getLogger().error(e.toString());
			e.printStackTrace();
		}finally{
			if(client!=null){
				FtpUtil.closeFtpClient(client);
				client = null;
			}
			if (sftp!=null){
				sftp.logout();
			}
			//把当前的连接关闭
			try {
				if(connect!=null){
					connect.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}finally{
				connect = null;
			}
		}
	}
 }